# -*- coding: utf-8 -*-
"""AI_TEST.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/13zN5lcUU2J70KqQBzGruLrioF2rf_844

#Task 2
"""

import numpy as np

points_test = []
Y = []
f = open('b_test.dat')
for line in f:
  points_test.append(list(map(float, line.split(' ')))[:-1])
  Y.append(int(list(map(float, line.split(' ')))[-1]))
points_test = np.array(points_test)

import pickle 
f = open("a.pkl", "rb")
clf = pickle.load(f)

from sklearn.tree import DecisionTreeClassifier
prediction = clf.predict(points_test)

# TP - 0
# TN - 1
# FP - 2
# FN - 3

matrix = []
for i in range(len(Y)):
  new_line = [1, 1, 1]
  if Y[i] == prediction[i]:
    new_line[Y[i]] = 0
  else:
    new_line[Y[i]] = 3
    new_line[prediction[i]] = 2
  matrix.append(new_line)
    
matrix = np.array(matrix)

for i in range(3):
  TP = len(np.where(np.array(matrix[:, i]) == 0)[0])
  TN = len(np.where(np.array(matrix[:, i]) == 1)[0])
  FP = len(np.where(np.array(matrix[:, i]) == 2)[0])
  FN = len(np.where(np.array(matrix[:, i]) == 3)[0])
  try:
    accuracy = (TP + TN) / (TP + TN + FP + FN)
  except ZeroDivisionError:
    accuracy = "N/A"
  try:
    recall = TP / (TP + FN)
  except ZeroDivisionError:
    recall = "N/A"
  try:  
    precision = TP / (TP + FP)
  except ZeroDivisionError:
    precision = "N/A"
  try:
    specificity = TN / (FP + TN)
  except ZeroDivisionError:
    specificity = "N/A"
  try:
    fall_out = FP / (FP + TN)
  except ZeroDivisionError:
    fall_out = "N/A"
  print(f"Class: {i}")
  print(f"Accuracy: {accuracy}")
  print(f"Recall: {recall}")
  print(f"Precision: {precision}")
  print(f"Specificity: {specificity}")
  print(f"Fall_out: {fall_out}")
  print("============\n")